Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:52 2008
FILE NAME: i.stomate_alloc.f90
PROGRAM NAME: stomate_alloc
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   183  vec  (   4): Vectorized array expression.
   189  ext  (  91): Format item that is not permitted by standard is used. (PT=20)
   190  ext  (  91): Format item that is not permitted by standard is used. (PT=43)
   222  opt  (1593): Loop nest collapsed into one loop.
   222  vec  (   4): Vectorized array expression.
   223  opt  (1593): Loop nest collapsed into one loop.
   223  vec  (   4): Vectorized array expression.
   232  vec  (   4): Vectorized array expression.
   238  vec  (   3): Unvectorized loop.
   238  vec  (   3): Unvectorized loop.
   240  opt  (1592): Outer loop unrolled inside inner loop.
   240  vec  (   4): Vectorized array expression.
   240  vec  (   4): Vectorized array expression.
   249  vec  (   4): Vectorized array expression.
   255  vec  (   3): Unvectorized loop.
   255  vec  (   3): Unvectorized loop.
   257  opt  (1592): Outer loop unrolled inside inner loop.
   257  vec  (   4): Vectorized array expression.
   257  vec  (   4): Vectorized array expression.
   271  vec  (   4): Vectorized array expression.
   274  vec  (   3): Unvectorized loop.
   274  vec  (  13): Overhead of loop division is too large.
   277  vec  (   4): Vectorized array expression.
   279  vec  (   4): Vectorized array expression.
   283  vec  (   4): Vectorized array expression.
   290  vec  (   3): Unvectorized loop.
   290  vec  (  13): Overhead of loop division is too large.
   293  vec  (   4): Vectorized array expression.
   295  vec  (   4): Vectorized array expression.
   304  vec  (   4): Vectorized array expression.
   314  opt  (1592): Outer loop unrolled inside inner loop.
   314  vec  (   4): Vectorized array expression.
   316  vec  (   2): Partially vectorized loop.
   316  vec  (  25): Work vectors are used. Size=288byte
   334  opt  (1082): Backward transfers inhibit loop optimization.
   334  vec  (   4): Vectorized array expression.
   353  opt  (1082): Backward transfers inhibit loop optimization.
   367  vec  (   4): Vectorized array expression.
   369  opt  (1082): Backward transfers inhibit loop optimization.
   369  vec  (   4): Vectorized array expression.
   380  vec  (   4): Vectorized array expression.
   390  vec  (   4): Vectorized array expression.
   390  vec  (   4): Vectorized array expression.
   390  vec  (   4): Vectorized array expression.
   408  vec  (   4): Vectorized array expression.
   421  vec  (   4): Vectorized array expression.
   489  vec  (   4): Vectorized array expression.
   501  vec  (   1): Vectorized loop.
   557  warn (  82): Name "zdiff_min" is not used.
   557  warn (  83): Dummy argument "rprof" is not used.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:52 2008
FILE NAME: i.stomate_alloc.f90
PROGRAM NAME: stomate_alloc
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            ! allocation to the roots, stems, leaves, "fruits" and carbohydrate reserve.
     2:            ! Reproduction: for the moment, this is simply a 10% "tax".
     3:            ! This should depend on the limitations that the plant experiences. If the
     4:            ! plant fares well, it will have fruits. However, this means that we should
     5:            ! also "reward" the plants for having grown fruits by making the
     6:            ! reproduction rate depend on the fruit growth of the past years. Otherwise,
     7:            ! the fruit allocation would be a punishment for plants that are doing well.
     8:            ! "calculates" root profiles (in fact, prescribes it for the moment).
     9:            !
    10:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/stomate_alloc.f90,v 1.9 2007/05/28 14:49:02 ssipsl Exp $
    11:            ! IPSL (2006)
    12:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
    13:            !
    14:            MODULE stomate_alloc
    15:            
    16:              ! modules used:
    17:            
    18:              USE ioipsl
    19:              USE stomate_constants
    20:            
    21:              IMPLICIT NONE
    22:            
    23:              ! private & public routines
    24:            
    25:              PRIVATE
    26:              PUBLIC alloc,alloc_clear
    27:            
    28:               ! first call
    29:                LOGICAL, SAVE                                             :: firstcall = .TRUE.
    30:            CONTAINS
    31:              SUBROUTINE alloc_clear
    32:                firstcall = .TRUE.
    33:              END SUBROUTINE alloc_clear
    34:            
    35:              SUBROUTINE alloc (npts, dt, &
    36:                                lai, veget_max, senescence, when_growthinit, &
    37:                                moiavail_week, tsoil_month, soilhum_month, &
    38:                                biomass, leaf_age, leaf_frac, rprof, f_alloc)
    39:            
    40:                !
    41:                ! 0 declarations
    42:                !
    43:            
    44:                ! 0.1 input
    45:            
    46:                ! Domain size
    47:                INTEGER(i_std), INTENT(in)                                       :: npts
    48:                ! time step (days)
    49:                REAL(r_std), INTENT(in)                                    :: dt
    50:                ! Leaf area index
    51:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)              :: lai
    52:                ! "maximal" coverage fraction of a PFT ( = ind*cn_ind )
    53:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)              :: veget_max
    54:                ! is the plant senescent? (only for deciduous trees - carbohydrate reserve)
    55:                LOGICAL, DIMENSION(npts,npft), INTENT(in)                 :: senescence
    56:                ! how many days ago was the beginning of the growing season
    57:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)              :: when_growthinit
    58:                ! "weekly" moisture availability
    59:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)              :: moiavail_week
    60:                ! "monthly" soil temperature (K)
    61:                REAL(r_std), DIMENSION(npts,nbdl), INTENT(in)              :: tsoil_month
    62:                ! "monthly" soil humidity
    63:                REAL(r_std), DIMENSION(npts,nbdl), INTENT(in)              :: soilhum_month
    64:            
    65:                ! 0.2 modified fields
    66:            
    67:                ! biomass (gC/m**2)
    68:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(inout)    :: biomass
    69:                ! leaf age (days)
    70:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout) :: leaf_age
    71:                ! fraction of leaves in leaf age class
    72:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout) :: leaf_frac
    73:            
    74:                ! 0.3 output
    75:            
    76:                ! root depth. This will, one day, be a prognostic variable. It will be calculated by
    77:                ! STOMATE (save in restart file & give to hydrology module!). For the moment, it
    78:                ! is prescribed.
    79:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)             :: rprof
    80:                ! fraction that goes into plant part
    81:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(out)      :: f_alloc
    82:            
    83:                ! 0.4 local
    84:            
    85:                ! Do we try to reach a minimum reservoir even if we are severely stressed?
    86:                LOGICAL, PARAMETER                                        :: ok_minres = .TRUE.
    87:                 ! time (d) to attain the initial foliage using the carbohydrate reserve
    88:                REAL(r_std), PARAMETER                                     :: tau_leafinit = 30.
    89:                ! maximum time (d) during which reserve is used (trees)
    90:                REAL(r_std), PARAMETER                                     :: reserve_time_tree = 60.
    91:                ! maximum time (d) during which reserve is used (grasses)
    92:                REAL(r_std), PARAMETER                                     :: reserve_time_grass = 30.
    93:                ! Standard root allocation
    94:                REAL(r_std), PARAMETER                                     :: R0 = 0.3
    95:                ! Standard sapwood allocation
    96:                REAL(r_std), PARAMETER                                     :: S0 = 0.3
    97:                ! Standard leaf allocation
    98:                REAL(r_std), PARAMETER                                     :: L0 = 1. - R0 - S0
    99:                ! Standard fruit allocation
   100:                REAL(r_std), PARAMETER                                     :: f_fruit = 0.1
   101:                ! fraction of sapwood allocation above ground (SHOULD BE CALCULATED !!!!)
   102:                REAL(r_std), PARAMETER                                     :: alloc_sap_above_tree = 0.5
   103:                REAL(r_std), PARAMETER                                     :: alloc_sap_above_grass = 1.0
   104:                ! extrema of leaf allocation fraction
   105:                REAL(r_std), PARAMETER                                     :: min_LtoLSR = 0.2
   106:                REAL(r_std), PARAMETER                                     :: max_LtoLSR = 0.5
   107:                ! below this lai, the carbohydrate reserve is used
   108:                REAL(r_std), DIMENSION(npft)                               :: lai_happy
   109:                ! limiting factor light
   110:                REAL(r_std), DIMENSION(npts)                               :: limit_L
   111:                ! limiting factor nitrogen
   112:                REAL(r_std), DIMENSION(npts)                               :: limit_N
   113:                ! factors determining limit_N: 1/ temperature
   114:                REAL(r_std), DIMENSION(npts)                               :: limit_N_temp
   115:                ! factors determining limit_N: 2/ humidity
   116:                REAL(r_std), DIMENSION(npts)                               :: limit_N_hum
   117:                ! limiting factor water
   118:                REAL(r_std), DIMENSION(npts)                               :: limit_W
   119:                ! limiting factor in soil (nitrogen or water)
   120:                REAL(r_std), DIMENSION(npts)                               :: limit_WorN
   121:                ! limit: strongest limitation amongst limit_N, limit_W and limit_L
   122:                REAL(r_std), DIMENSION(npts)                               :: limit
   123:                ! scaling depth for nitrogen limitation (m)
   124:                REAL(r_std), PARAMETER                                     :: z_nitrogen = 0.2
   125:                ! soil temperature used for N parameterization
   126:                REAL(r_std), DIMENSION(npts)                               :: t_nitrogen
   127:                ! soil humidity used for N parameterization
   128:                REAL(r_std), DIMENSION(npts)                               :: h_nitrogen
   129:                ! integration constant for vertical profiles
   130:                REAL(r_std), DIMENSION(npts)                               :: rpc
   131:                ! ratio between leaf-allocation and (leaf+sapwood+root)-allocation
   132:                REAL(r_std), DIMENSION(npts)                               :: LtoLSR
   133:                ! ratio between sapwood-allocation and (leaf+sapwood+root)-allocation
   134:                REAL(r_std), DIMENSION(npts)                               :: StoLSR
   135:                ! ratio between root-allocation and (leaf+sapwood+root)-allocation
   136:                REAL(r_std), DIMENSION(npts)                               :: RtoLSR
   137:                ! rescaling factor for carbohydrate reserve allocation
   138:                REAL(r_std), DIMENSION(npts)                               :: carb_rescale
   139:                ! mass taken from carbohydrate reserve (gC/m**2)
   140:                REAL(r_std), DIMENSION(npts)                               :: use_reserve
   141:                ! mass taken from carbohydrate reserve and put into leaves (gC/m**2)
   142:                REAL(r_std), DIMENSION(npts)                               :: transloc_leaf
   143:                ! mass in youngest leaf age class (gC/m**2)
   144:                REAL(r_std), DIMENSION(npts)                               :: leaf_mass_young
   145:                ! old leaf biomass (gC/m**2)
   146:                REAL(r_std), DIMENSION(npts,npft)                          :: lm_old
   147:                ! maximum time (d) during which reserve is used
   148:                REAL(r_std)                                                :: reserve_time
   149:                ! lai on natural part of the grid cell, or of this agricultural PFT
   150:                REAL(r_std), DIMENSION(npts,npft)                          :: lai_around
   151:                ! vegetation cover of natural PFTs on the grid cell (agriculture masked)
   152:                REAL(r_std), DIMENSION(npts,npft)                          :: veget_max_nat 
   153:                ! total natural vegetation cover on natural part of the grid cell
   154:                REAL(r_std), DIMENSION(npts)                               :: natveg_tot
   155:                ! average LAI on natural part of the grid cell
   156:                REAL(r_std), DIMENSION(npts)                               :: lai_nat
   157:                ! intermediate array for looking for minimum
   158:                REAL(r_std), DIMENSION(npts)                               :: zdiff_min
   159:                ! fraction of sapwood allocation above ground (SHOULD BE CALCULATED !!!!)
   160:                REAL(r_std)                                                :: alloc_sap_above
   161:                ! soil levels (m)
   162:                REAL(r_std), SAVE, DIMENSION(0:nbdl)                       :: z_soil
   163:                ! Index
   164:                INTEGER(i_std)                                            :: i,j,l,m
   165:            
   166:                ! =========================================================================
   167:            
   168:                IF (bavard.GE.3) WRITE(numout,*) 'Entering alloc'
   169:            
   170:                !
   171:                ! 1 Initialization
   172:                !
   173:            
   174:                !
   175:                ! 1.1 first call
   176:                !
   177:            
   178:                IF ( firstcall ) THEN
   179:            
   180:                  ! 1.1.1 soil levels
   181:            
   182:                  z_soil(0) = 0.
   183: V======          z_soil(1:nbdl) = diaglev(1:nbdl)
   184:            
   185:                  ! 1.1.2 info about flags and parameters.
   186:            
   187:                  WRITE(numout,*) 'alloc:'
   188:            
   189:                  WRITE(numout,'(a,$)') '    > We'
   190:                  IF ( .NOT. ok_minres ) WRITE(numout,'(a,$)') ' do NOT'
   191:                  WRITE(numout,*) 'try to reach a minumum reservoir when severely stressed.'
   192:            
   193:                  WRITE(numout,*) '   > Time to put initial leaf mass on (d): ',tau_leafinit
   194:            
   195:                  WRITE(numout,*) '   > scaling depth for nitrogen limitation (m): ', &
   196:                                  z_nitrogen
   197:            
   198:                  WRITE(numout,*) '   > sap allocation above the ground / total sap allocation: '
   199:                  WRITE(numout,*) '       trees:', alloc_sap_above_tree
   200:                  WRITE(numout,*) '       grasses:', alloc_sap_above_grass
   201:            
   202:                  WRITE(numout,*) '   > standard root alloc fraction: ', R0
   203:            
   204:                  WRITE(numout,*) '   > standard sapwood alloc fraction: ', S0
   205:            
   206:                  WRITE(numout,*) '   > standard fruit allocation: ', f_fruit
   207:            
   208:                  WRITE(numout,*) '   > minimum/maximum leaf alloc fraction: ', min_LtoLSR,max_LtoLSR
   209:            
   210:                  WRITE(numout,*) '   > maximum time (d) during which reserve is used:'
   211:                  WRITE(numout,*) '       trees:',reserve_time_tree
   212:                  WRITE(numout,*) '       grasses:',reserve_time_grass
   213:            
   214:                  firstcall = .FALSE.
   215:            
   216:                ENDIF
   217:            
   218:                !
   219:                ! 1.2 initialize output
   220:                !
   221:            
   222: WW*====        f_alloc(:,:,:) = 0.0
   223: **=====        f_alloc(:,:,icarbres) = 1.0
   224:                !
   225:                ! 1.3 Convolution of the temperature and humidity profiles with some kind of profile
   226:                !     of microbial density gives us a representative temperature and humidity 
   227:                !
   228:            
   229:                ! 1.3.1 temperature
   230:            
   231:                ! 1.3.1.1 rpc is an integration constant such that the integral of the root profile is 1.
   232: V------>       rpc(:) = 1. / ( 1. - EXP( -z_soil(nbdl) / z_nitrogen ) )
   233: |          
   234: |              ! 1.3.1.2 integrate over the nbdl levels
   235: |          
   236: V------        t_nitrogen(:) = 0.
   237:            
   238: +------>       DO l = 1, nbdl
   239: |          
   240: |V=====          t_nitrogen(:) = &
   241: |                  t_nitrogen(:) + tsoil_month(:,l) * rpc(:) * &
   242: |                                  ( EXP( -z_soil(l-1)/z_nitrogen ) - EXP( -z_soil(l)/z_nitrogen ) )
   243: |          
   244: +------        ENDDO
   245:            
   246:                ! 1.3.2 moisture
   247:            
   248:                ! 1.3.2.1 rpc is an integration constant such that the integral of the root profile is 1.
   249: V------>       rpc(:) = 1. / ( 1. - EXP( -z_soil(nbdl) / z_nitrogen ) )
   250: |          
   251: |              ! 1.3.2.2 integrate over the nbdl levels
   252: |          
   253: V------        h_nitrogen(:) = 0.0
   254:            
   255: +------>       DO l = 1, nbdl
   256: |          
   257: |V=====          h_nitrogen(:) = &
   258: |                  h_nitrogen(:) + soilhum_month(:,l) * rpc(:) * &
   259: |                                  ( EXP( -z_soil(l-1)/z_nitrogen ) - EXP( -z_soil(l)/z_nitrogen ) )
   260: |          
   261: +------        ENDDO
   262:            
   263:                !
   264:                ! 1.4 for light limitation: lai on natural part of the grid cell or lai of this
   265:                !       agricultural PFT
   266:                !
   267:            
   268:                ! mask agricultural vegetation
   269:                ! mean LAI on natural part
   270:            
   271: V------>       natveg_tot(:) = 0.0
   272: V------        lai_nat(:) = 0.0
   273:            
   274: +------>       DO j = 1, npft
   275: |          
   276: |                IF ( natural(j) ) THEN
   277: |V=====            veget_max_nat(:,j) = veget_max(:,j)
   278: |                ELSE
   279: |V=====            veget_max_nat(:,j) = 0.0
   280: |                ENDIF
   281: |          
   282: |                ! sum up fraction of natural space covered by vegetation
   283: |V----->         natveg_tot(:) = natveg_tot(:) + veget_max_nat(:,j)
   284: ||         
   285: ||               ! sum up lai
   286: |V-----          lai_nat(:) = lai_nat(:) + veget_max_nat(:,j) * lai(:,j)
   287: |          
   288: +------        ENDDO
   289:            
   290: +------>       DO j = 1, npft
   291: |          
   292: |                IF ( natural(j) ) THEN
   293: |V=====            lai_around(:,j) = lai_nat(:)
   294: |                ELSE
   295: |V=====            lai_around(:,j) = lai(:,j)
   296: |                ENDIF
   297: |          
   298: +------        ENDDO
   299:            
   300:                !
   301:                ! 1.5 LAI below which carbohydrate reserve is used
   302:                !
   303:            
   304: V======        lai_happy(:) = lai_max(:) * 0.5
   305:            
   306:                !
   307:                ! 2 Use carbohydrate reserve
   308:                !   This time constant implicitly takes into account the dispersion of the budburst
   309:                !   data. Therefore, it might be decreased at lower resolution.
   310:                !
   311:            
   312:                ! save old leaf mass
   313:            
   314: +V=====        lm_old(:,:) = biomass(:,:,ileaf)
   315:            
   316: V------>       DO j = 1, npft
   317: |          
   318: |                !
   319: |                ! 2.1 determine mass to be translocated to leaves and roots
   320: |                !
   321: |          
   322: |                ! determine maximum time during which reserve is used
   323: |          
   324: |                IF ( tree(j) ) THEN
   325: |                  reserve_time = reserve_time_tree
   326: |                ELSE
   327: |                  reserve_time = reserve_time_grass
   328: |                ENDIF
   329: |          
   330: |                ! conditions: 1/ plant must not be senescent
   331: |                !             2/ lai must be relatively low
   332: |                !             3/ must be at the beginning of the growing season
   333: |          
   334: |V----->         WHERE ( ( biomass(:,j,ileaf) .GT. 0.0 ) .AND. & 
   335: ||                       ( .NOT. senescence(:,j) ) .AND. &
   336: ||                       ( lai(:,j) .LT. lai_happy(j) ) .AND. &
   337: ||                       ( when_growthinit(:,j) .LT. reserve_time ) ) 
   338: ||         
   339: ||                 ! determine mass to put on
   340: ||                 use_reserve(:) = &
   341: ||                    MIN( biomass(:,j,icarbres), &
   342: ||                           2._r_std * dt/tau_leafinit * lai_happy(j) * veget_max(:,j) / sla(j) )
   343: ||         
   344: ||                 ! grow leaves and fine roots
   345: ||         
   346: ||                 transloc_leaf(:) = L0/(L0+R0) * use_reserve(:)
   347: ||         
   348: ||                 biomass(:,j,ileaf) = biomass(:,j,ileaf) + transloc_leaf(:)
   349: ||                 biomass(:,j,iroot) = biomass(:,j,iroot) + ( use_reserve(:) - transloc_leaf(:) )
   350: ||         
   351: ||                 ! decrease reserve mass
   352: ||         
   353: ||                 biomass(:,j,icarbres) = biomass(:,j,icarbres) - use_reserve(:)
   354: ||         
   355: ||               ELSEWHERE
   356: ||         
   357: |V-----            transloc_leaf(:) = 0.0
   358: |          
   359: |                ENDWHERE
   360: |          
   361: |                !
   362: |                ! 2.2 update leaf age
   363: |                !
   364: |          
   365: |                ! 2.2.1 Decrease leaf age in youngest class.
   366: |          
   367: |V=====          leaf_mass_young(:) = leaf_frac(:,j,1) * lm_old(:,j) + transloc_leaf(:)
   368: |          
   369: |V----->         WHERE ( ( transloc_leaf(:) .GT. 0.0 ) .AND. ( leaf_mass_young(:) .GT. 0.0 ) )
   370: ||         
   371: |V-----            leaf_age(:,j,1) = leaf_age(:,j,1) * ( leaf_mass_young(:) - transloc_leaf(:) ) / &
   372: |                                                        leaf_mass_young(:)
   373: |          
   374: |                ENDWHERE
   375: |          
   376: |                ! 2.2.2 new age class fractions (fraction in youngest class increases)
   377: |          
   378: |                ! 2.2.2.1 youngest class: new mass in youngest class divided by total new mass
   379: |          
   380: |V----->         WHERE ( biomass(:,j,ileaf) .GT. min_stomate )
   381: ||         
   382: |V-----            leaf_frac(:,j,1) = leaf_mass_young(:) / biomass(:,j,ileaf)
   383: |          
   384: |                ENDWHERE
   385: |          
   386: |                ! 2.2.2.2 other classes: old mass in leaf age class divided by new mass
   387: |          
   388: |*----->         DO m = 2, nleafages
   389: ||         
   390: ||V---->           WHERE ( biomass(:,j,ileaf) .GT. min_stomate )
   391: |||        
   392: ||V----              leaf_frac(:,j,m) = leaf_frac(:,j,m) * lm_old(:,j) / biomass(:,j,ileaf)
   393: ||         
   394: ||                 ENDWHERE
   395: ||         
   396: |*-----          ENDDO
   397: |          
   398: V------        ENDDO         ! loop over PFTs
   399:            
   400:                !
   401:                ! 3 Calculate fractional allocation.
   402:                !   The fractions of NPP allocated to the different compartments depend on the
   403:                !   availability of light, water, and nitrogen.
   404:                !
   405:            
   406: +------>       DO j = 1, npft
   407: |          
   408: |V----->          RtoLSR(:)=0
   409: ||                LtoLSR(:)=0
   410: |V-----           StoLSR(:)=0
   411: |                ! for the moment, fixed partitioning between above and below the ground
   412: |           
   413: |                IF ( tree(j) ) THEN
   414: |                  alloc_sap_above = alloc_sap_above_tree
   415: |                ELSE
   416: |                  alloc_sap_above = alloc_sap_above_grass
   417: |                ENDIF
   418: |          
   419: |                ! only where leaves are on
   420: |          
   421: |V----->         WHERE ( biomass(:,j,ileaf) .GT. min_stomate )
   422: ||         
   423: ||                 !
   424: ||                 ! 3.1 Limiting factors: weak value = strong limitation
   425: ||                 !
   426: ||         
   427: ||                 ! 3.1.1 Light: depends on mean lai on the natural part of the
   428: ||                 !       grid box (light competition).
   429: ||                 !       For agricultural PFTs, take its own lai for both parts.
   430: ||         
   431: ||                 limit_L(:) = MAX( 0.1_r_std, exp( -0.5_r_std * lai_around(:,j) ) )
   432: ||         
   433: ||                 ! 3.1.2 Water
   434: ||         
   435: ||                 limit_W(:) = MAX( 0.1_r_std, MIN( 1._r_std, moiavail_week(:,j) ) )
   436: ||         
   437: ||                 ! 3.1.3 Nitrogen supply: depends on water and temperature
   438: ||                 !       Agricultural PFTs can be limited by Nitrogen for the moment ...
   439: ||                 !       Replace this once there is a nitrogen cycle in STOMATE !
   440: ||         
   441: ||                 ! 3.1.3.1 water 
   442: ||         
   443: ||                 limit_N_hum(:) = MAX( 0.5_r_std, MIN( 1._r_std, h_nitrogen(:) ) )
   444: ||         
   445: ||                 ! 3.1.3.2 temperature
   446: ||         
   447: ||                 limit_N_temp(:) = 2.**((t_nitrogen(:)-ZeroCelsius-25.)/10.)
   448: ||                 limit_N_temp(:) = MAX( 0.1_r_std, MIN( 1._r_std, limit_N_temp(:) ) )
   449: ||         
   450: ||                 ! 3.1.3.3 combine water and temperature factors to get nitrogen limitation
   451: ||         
   452: ||                 limit_N(:) = MAX( 0.1_r_std, MIN( 1._r_std, limit_N_hum(:) * limit_N_temp(:) ) )
   453: ||         
   454: ||                 ! 3.1.4 Among water and nitrogen, take the one that is more limited
   455: ||         
   456: ||                 limit_WorN(:) = MIN( limit_W(:), limit_N(:) )
   457: ||         
   458: ||                 ! 3.1.5 strongest limitation
   459: ||         
   460: ||                 limit(:) = MIN( limit_WorN(:), limit_L(:) )
   461: ||         
   462: ||                 !
   463: ||                 ! 3.2 Ratio between allocation to leaves, sapwood and roots
   464: ||                 !
   465: ||         
   466: ||                 ! preliminary root allocation
   467: ||         
   468: ||                 RtoLSR(:) = &
   469: ||                   MAX( .15_r_std, &
   470: ||                          R0 * 3._r_std * limit_L(:) / ( limit_L(:) + 2._r_std * limit_WorN(:) ) )
   471: ||          
   472: ||                 ! sapwood allocation
   473: ||         
   474: ||                 StoLSR(:) = S0 * 3. * limit_WorN(:) / ( 2. * limit_L(:) + limit_WorN(:) )
   475: ||         
   476: ||                 ! leaf allocation
   477: ||         
   478: ||                 LtoLSR(:) = 1. - RtoLSR(:) - StoLSR(:)
   479: ||                 LtoLSR(:) = MAX( min_LtoLSR, MIN( max_LtoLSR, LtoLSR(:) ) )
   480: ||         
   481: ||                 ! roots: the rest
   482: ||         
   483: |V-----            RtoLSR(:) = 1. - LtoLSR(:) - StoLSR(:)
   484: |          
   485: |                ENDWHERE
   486: |           
   487: |                ! no leaf allocation if LAI beyond maximum LAI. Biomass then goes into sapwood
   488: |          
   489: |V----->         WHERE ( (biomass(:,j,ileaf) .GT. min_stomate) .AND. (lai(:,j) .GT. lai_max(j)) )
   490: ||         
   491: ||                 StoLSR(:) = StoLSR(:) + LtoLSR(:)
   492: ||         
   493: |V-----            LtoLSR(:) = 0.0
   494: |          
   495: |                ENDWHERE
   496: |          
   497: |                !
   498: |                ! 3.3 final allocation
   499: |                !
   500: |          
   501: |V----->         DO i = 1, npts
   502: ||         
   503: ||                 IF ( biomass(i,j,ileaf) .GT. min_stomate ) THEN
   504: ||         
   505: ||                   IF ( senescence(i,j) ) THEN
   506: ||         
   507: ||                     ! 3.3.1 senescent: everything goes into carbohydrate reserve
   508: ||         
   509: ||                     f_alloc(i,j,icarbres) = 1.0
   510: ||         
   511: ||                   ELSE
   512: ||         
   513: ||                     ! 3.3.2 in growing season
   514: ||         
   515: ||                     ! to fruits
   516: ||                     f_alloc(i,j,ifruit) = f_fruit
   517: ||         
   518: ||                     ! allocation to the reserve is proportional to the leaf and root allocation.
   519: ||                     ! Leaf, root, and sap allocation are rescaled.
   520: ||                     ! No allocation to reserve if there is much biomass in it 
   521: ||                     !   (more than the maximum LAI: in that case, rescale=1)
   522: ||         
   523: ||                     IF ( ( biomass(i,j,icarbres)*sla(j)/veget_max(i,j) ) .LT. lai_max(j) ) THEN
   524: ||                       carb_rescale(i) = 1. / ( 1. + ecureuil(j) * ( LtoLSR(i) + RtoLSR(i) ) )
   525: ||                     ELSE
   526: ||                       carb_rescale(i) = 1.
   527: ||                     ENDIF
   528: ||         
   529: ||                     f_alloc(i,j,ileaf) = LtoLSR(i) * ( 1.-f_alloc(i,j,ifruit) ) * carb_rescale(i)
   530: ||         
   531: ||                     f_alloc(i,j,isapabove) = StoLSR(i) * alloc_sap_above * &
   532: ||                                              ( 1. - f_alloc(i,j,ifruit) ) * carb_rescale(i)
   533: ||                     f_alloc(i,j,isapbelow) = StoLSR(i) * ( 1. - alloc_sap_above ) * &
   534: ||                                              ( 1. - f_alloc(i,j,ifruit) ) * carb_rescale(i)
   535: ||         
   536: ||                     f_alloc(i,j,iroot) = RtoLSR(i) * ( 1.-f_alloc(i,j,ifruit) ) * carb_rescale(i)
   537: ||             
   538: ||                     ! this is equivalent to:
   539: ||                     ! reserve alloc = ecureuil*(LtoLSR+StoLSR)*(1-fruit_alloc)*carb_rescale
   540: ||                     f_alloc(i,j,icarbres) = ( 1. - carb_rescale(i) ) * ( 1.-f_alloc(i,j,ifruit) )
   541: ||         
   542: ||                   ENDIF  ! senescent?
   543: ||           
   544: ||                 ENDIF    ! there are leaves
   545: ||         
   546: |V-----          ENDDO      ! Fortran95: double WHERE construct
   547: |          
   548: +------        ENDDO          ! loop over PFTs
   549:            
   550:                !
   551:                ! 4 root profile
   552:                !
   553:            
   554:            
   555:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving alloc'
   556:            
   557:              END SUBROUTINE alloc
   558:            
   559:            
   560:            END MODULE stomate_alloc
